{ ****************************************************************** }
{                                                                    }
{   VCL component TPSCircleGauge                                     }
{                                                                    }
{   This is a circle gauge based on RingGauge By Tom Lee             }
{                                                                    }
{   Code generated by Component Create for Delphi                    }
{                                                                    }
{   Generated from source file d:\my documents\delphi_3\_psgauges\components\pscgauge.cd }
{   on 1 Jan 2001 at 9:45                                            }
{                                                                    }
{   Copyright  2000 by ... PatSoft                                  }
{                                                                    }
{ ****************************************************************** }

unit PSCGauge;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics, Dialogs, Extctrls;

{****************************************************************************}
{                           NOTES                                            }
{ The ProgressValue is a bit of a problem in that this is used to work out   }
{ the coordinace to do the flood fill. If the flodfill is outside the ring   }
{ then the whole component is filled wth the ring foregrond color. To        }
{ compensate for this i have had to adjust the minimum value of the          }
{ progressvalue when passed to the DrawGauge Routine. The adjusted value is  }
{ at least the MaxValue divided by 100 mulitiplied by a drawing factor       }
{ ***************************************************************************}

{*************************** Acknowledgements *******************************}
{ This is a circle gauge based on RingGauge By Tom Lee. Below is the message }
{ at the start of the RingGauge component                                    }
{ Written By Tom Lee,Taiwan Ver 0.94 Beta Tomm.bbs@[140.113.17.154]          }
{                                                                            }
{                                                                            }
{ I grabbed this component off the www.torry.ru web site. Thanks to Tom Lee  }
{ for making his component freeware with the code.                           }
{ I have used tom code that worked out the X and Y co-ordinates from the     }
{ angles and other things.                                                   }
{ I first changed the variable names tom used to something that was easier to}
{ understannd and then i hacked the code to pieces.                          }
{ My component is also freeware with the code. If you modify it please send  }
{ me a copy of the new component and the code.                               }
{ The code was developed by me using a copy of  Component Create version 4.0 }
{ http://www.compcreate.com. I also grabbed this gem from the www.torry.ru   }
{ web site it is very good. Get it and try it.                               }
{ If you have Problems e-mail me at peter.cook@qr.com.au                     }
{****************************************************************************}




type
  TPSCircleGauge = class(TGraphicControl)
    private
      { Private fields of TPSCircleGauge }
        { Storage for property BackgroundColor }
        FBackgroundColor : TColor;
        { Storage for property CaptionFontSize }
        FCaptionFontSize : Integer;
        { Storage for property ErrorChecking }
        FErrorChecking : Boolean;
        { Storage for property HasOutline }
        FHasOutline : Boolean;
        { Storage for property IndicatorColor }
        FIndicatorColor : TColor;
        { Storage for property IndicatorFontSize }
        FIndicatorFontSize : Integer;
        { Storage for property MaxValue }
        FMaxValue : Longint;
        { Storage for property MinValue }
        FMinValue : Longint;
        { Storage for property ProgressValue }
        FProgressValue : Longint;
        { Storage for property RingBackgroundColor }
        FRingBackgroundColor : TColor;
        { Storage for property RingForegroundColor }
        FRingForegroundColor : TColor;
        { Storage for property RingWidth }
        FRingWidth : Byte;
        { Storage for property SectorDegree }
        FSectorDegree : Integer;
        { This the bitmap buffer that the drawing will be done to first. }
        BackBuffer : TBitmap;
        GaugeHeight : Integer;
        GaugeLeft : Integer;

      { Private methods of TPSCircleGauge }
        { Method to set variable and property values and create objects }
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;
        { Read method for property BackgroundColor }
        function GetBackgroundColor : TColor;
        { Write method for property BackgroundColor }
        procedure SetBackgroundColor(Value : TColor);
        { Read method for property CaptionFontSize }
        function GetCaptionFontSize : Integer;
        { Write method for property CaptionFontSize }
        procedure SetCaptionFontSize(Value : Integer);
        { Read method for property ErrorChecking }
        function GetErrorChecking : Boolean;
        { Write method for property ErrorChecking }
        procedure SetErrorChecking(Value : Boolean);
        { Read method for property HasOutline }
        function GetHasOutline : Boolean;
        { Write method for property HasOutline }
        procedure SetHasOutline(Value : Boolean);
        { Read method for property IndicatorColor }
        function GetIndicatorColor : TColor;
        { Write method for property IndicatorColor }
        procedure SetIndicatorColor(Value : TColor);
        { Read method for property IndicatorFontSize }
        function GetIndicatorFontSize : Integer;
        { Write method for property IndicatorFontSize }
        procedure SetIndicatorFontSize(Value : Integer);
        { Read method for property MaxValue }
        function GetMaxValue : Longint;
        { Write method for property MaxValue }
        procedure SetMaxValue(Value : Longint);
        { Read method for property MinValue }
        function GetMinValue : Longint;
        { Write method for property MinValue }
        procedure SetMinValue(Value : Longint);
        { Read method for property ProgressValue }
        function GetProgressValue : Longint;
        { Write method for property ProgressValue }
        procedure SetProgressValue(Value : Longint);
        { Read method for property RingBackgroundColor }
        function GetRingBackgroundColor : TColor;
        { Write method for property RingBackgroundColor }
        procedure SetRingBackgroundColor(Value : TColor);
        { Read method for property RingForegroundColor }
        function GetRingForegroundColor : TColor;
        { Write method for property RingForegroundColor }
        procedure SetRingForegroundColor(Value : TColor);
        { Read method for property RingWidth }
        function GetRingWidth : Byte;
        { Write method for property RingWidth }
        procedure SetRingWidth(Value : Byte);
        { Read method for property SectorDegree }
        function GetSectorDegree : Integer;
        { Write method for property SectorDegree }
        procedure SetSectorDegree(Value : Integer);
        function AdjustProgressValue(ProgressValue : Integer) : Integer;
        { This converts a degrees amount to Rads }
        function DegToRad(InputDegrees: Double) : Double;
        procedure DrawArcs( GaugeLeft, GaugeTop, GaugeRight, GaugeBottom, OuterRadius, InnerRadius, HalfTheSectorDegree, D1, D2: Integer);
        procedure DrawBackground;
        procedure DrawCaptionText;
        procedure DrawGauge( GaugeLeft, GaugeTop, GaugeRight, GaugeBottom, OuterRadius, InnerRadius, TheSectorDegree, TheProgressValue: Integer);
        { Draws the current Progress value as text in the middle of gauge }
        procedure DrawValueText;
        { This procedure flips the contents of the backbuffer to the screen }
        procedure FlipBuffers;
        { Returns an X point on an arc by using the degrees }
        function GetArcPointX(Degrees : Double; GaugeLeft, GaugeRight, OuterOrInnerRadius: Integer) : Integer;
        { Returns an Y point on an arc by using the degrees }
        function GetArcPointY(Degrees : Double; GaugeTop, GaugeBottom, OuterOrInnerRadius : Integer) : Integer;
        function GetR(x1, x2 : Integer) : integer;
        function GetRx(x1,x2 : Integer) : Integer;
        function GetRy(y1, y2 : Integer) : integer;
        procedure WMSize(var Message: TWMSize); message WM_SIZE;

    protected
      { Protected fields of TPSCircleGauge }
        { Used to adjust the minimum amount of the ring floodfilled }
        DrawFactor : Integer;
        DrawStyle : Integer;
        GaugeBottom : Integer;
        GaugeRight : Integer;
        GaugeTop : Integer;
        GaugeWidth : Integer;
        { This is the OuterRaidus Less the BarWidth }
        InnerRadius : Integer;
        OuterRadius : Integer;

      { Protected methods of TPSCircleGauge }
        procedure Click; override;
        procedure DblClick; override;
        procedure DragDrop(DragObject: TObject; X, Y: Integer); override;
        procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
        procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
        procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
        procedure CaptionTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
        procedure Loaded; override;
        procedure Paint; override;

    public
      { Public fields and properties of TPSCircleGauge }

      { Public methods of TPSCircleGauge }
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;

    published
      { Published properties of TPSCircleGauge }
        property OnClick;
        property OnDblClick;
        property OnDragDrop;
        property OnMouseDown;
        property OnMouseMove;
        property OnMouseUp;
        { This is the background color of the component }
        property BackgroundColor : TColor
             read GetBackgroundColor write SetBackgroundColor
             default clSilver;
        { This is used to draw the name of the gauge at the top middle }
        property Caption;
        { Size of the font used on the gauge to display the value. }
        property CaptionFontSize : Integer
             read GetCaptionFontSize write SetCaptionFontSize
             default 10;
        { This turns the error message system on or off }
        property ErrorChecking : Boolean
             read GetErrorChecking write SetErrorChecking
             default True;
        { Turns the outline of the component on or off }
        property HasOutline : Boolean
             read GetHasOutline write SetHasOutline
             default True;
        { Height of the component }
        property Height default 300;
        { This is the color of the increment marks on the gauge }
        property IndicatorColor : TColor
             read GetIndicatorColor write SetIndicatorColor
             default clBlack;
        { Size of the font used around the indicator. }
        property IndicatorFontSize : Integer
             read GetIndicatorFontSize write SetIndicatorFontSize
             default 10;
        { This is the maximum value to be displayed }
        property MaxValue : Longint
             read GetMaxValue write SetMaxValue
             default 100;
        { The minimum value that the gauge can display }
        property MinValue : Longint
             read GetMinValue write SetMinValue
             default 0;
        { This the progess of the meter. }
        property ProgressValue : Longint
             read GetProgressValue write SetProgressValue;
        { This is the color of the ringthat will seem to be the background }
        property RingBackgroundColor : TColor
             read GetRingBackgroundColor write SetRingBackgroundColor
             default clSilver;
        { This is the color of the setion that will seem to move. }
        property RingForegroundColor : TColor
             read GetRingForegroundColor write SetRingForegroundColor
             default clBlue;
        { This is the width which the ring will be drawn. }
        property RingWidth : Byte
             read GetRingWidth write SetRingWidth
             default 15;
        { This is the amount of degrees between the two open ends }
        property SectorDegree : Integer
             read GetSectorDegree write SetSectorDegree
             default 60;
        { The width of the gauge }
        property Width default 300;

  end;

procedure Register;

implementation

procedure Register;
begin
     { Register TPSCircleGauge with Gauges as its
       default page on the Delphi component palette }
     RegisterComponents('Gauges', [TPSCircleGauge]);
end;

{ Method to set variable and property values and create objects }
procedure TPSCircleGauge.AutoInitialize;
begin
     BackBuffer := TBitmap.Create;
     DrawFactor := 0;
     GaugeHeight := 0;
     GaugeLeft := 0;
     FBackgroundColor := clSilver;
     FCaptionFontSize := 10;
     FErrorChecking := True;
     FHasOutline := True;
     Height := 300;
     FIndicatorColor := clBlack;
     FIndicatorFontSize := 10;
     FMaxValue := 100;
     FMinValue := 0;
     FRingBackgroundColor := clSilver;
     FRingForegroundColor := clBlue;
     FRingWidth := 15;
     FSectorDegree := 60;
     Width := 300;
end; { of AutoInitialize }

{ Method to free any objects created by AutoInitialize }
procedure TPSCircleGauge.AutoDestroy;
begin
     BackBuffer.Free;
end; { of AutoDestroy }

{ Read method for property BackgroundColor }
function TPSCircleGauge.GetBackgroundColor : TColor;
begin
     Result := FBackgroundColor;
end;

{ Write method for property BackgroundColor }
procedure TPSCircleGauge.SetBackgroundColor(Value : TColor);
begin
     if FBackgroundColor <> Value then begin
        FBackgroundColor := Value;
        Invalidate;
     end;
end;

{ Read method for property CaptionFontSize }
function TPSCircleGauge.GetCaptionFontSize : Integer;
begin
     Result := FCaptionFontSize;
end;

{ Write method for property CaptionFontSize }
procedure TPSCircleGauge.SetCaptionFontSize(Value : Integer);
begin
     if FCaptionFontSize <> Value then begin
        FCaptionFontSize := Value;
        Invalidate;
     end;
end;

{ Read method for property ErrorChecking }
function TPSCircleGauge.GetErrorChecking : Boolean;
begin
     Result := FErrorChecking;
end;

{ Write method for property ErrorChecking }
procedure TPSCircleGauge.SetErrorChecking(Value : Boolean);
begin
    if FErrorChecking <> Value then begin
       FErrorChecking := Value;
       Invalidate;
    end;
end;

{ Read method for property HasOutline }
function TPSCircleGauge.GetHasOutline : Boolean;
begin
     Result := FHasOutline;
end;

{ Write method for property HasOutline }
procedure TPSCircleGauge.SetHasOutline(Value : Boolean);
begin
     if FHasOutline <> Value then begin
        FHasOutline := Value;
        Invalidate;
     end;
end;

{ Read method for property IndicatorColor }
function TPSCircleGauge.GetIndicatorColor : TColor;
begin
     Result := FIndicatorColor;
end;

{ Write method for property IndicatorColor }
procedure TPSCircleGauge.SetIndicatorColor(Value : TColor);
begin
     if FIndicatorColor <> Value then begin
        FIndicatorColor := Value;
        Invalidate;
     end;
end;

{ Read method for property IndicatorFontSize }
function TPSCircleGauge.GetIndicatorFontSize : Integer;
begin
     Result := FIndicatorFontSize;
end;

{ Write method for property IndicatorFontSize }
procedure TPSCircleGauge.SetIndicatorFontSize(Value : Integer);
begin
     If FIndicatorFontSize <> Value then begin
        FIndicatorFontSize := Value;
        Invalidate;
     end;
end;

{ Read method for property MaxValue }
function TPSCircleGauge.GetMaxValue : Longint;
begin
     Result := FMaxValue;
end;

{ Write method for property MaxValue }
procedure TPSCircleGauge.SetMaxValue(Value : Longint);
begin
     if FMaxValue <> Value then begin
        FMaxValue := Value;
        Invalidate;
     end;
end;

{ Read method for property MinValue }
function TPSCircleGauge.GetMinValue : Longint;
begin
     Result := FMinValue;
end;

{ Write method for property MinValue }
procedure TPSCircleGauge.SetMinValue(Value : Longint);
begin
     if FMinValue <> Value then begin
        FMinValue := Value;
        Invalidate;
     end;
end;

{ Read method for property ProgressValue }
function TPSCircleGauge.GetProgressValue : Longint;
begin
     Result := FProgressValue;
end;

{ Write method for property ProgressValue }
procedure TPSCircleGauge.SetProgressValue(Value : Longint);
begin
     {Make sure the Progress value is within the limits of the
      MinValue and MaxValues}
     IF Value < GetMinValue then begin
        If GetErrorChecking then Showmessage('Progress Value can not be less than Minimum Value');
        Value := GetMinValue;
     end;

     IF Value > GetMaxValue then begin
        If GetErrorChecking then Showmessage('Progress Value can not be more than Maximum Value');
        Value := GetMaxValue;
     end;
     
     if FProgressValue <> Value then begin
        FProgressValue := Value;
        Invalidate;
     end;
     
end;

{ Read method for property RingBackgroundColor }
function TPSCircleGauge.GetRingBackgroundColor : TColor;
begin
     Result := FRingBackgroundColor;
end;

{ Write method for property RingBackgroundColor }
procedure TPSCircleGauge.SetRingBackgroundColor(Value : TColor);
begin
     if FRingBackgroundColor <> Value then begin
        FRingBackgroundColor := Value;
        Invalidate;
     end;
end;

{ Read method for property RingForegroundColor }
function TPSCircleGauge.GetRingForegroundColor : TColor;
begin
     Result := FRingForegroundColor;
end;

{ Write method for property RingForegroundColor }
procedure TPSCircleGauge.SetRingForegroundColor(Value : TColor);
begin
      if FRingForegroundColor <> Value then begin
         FRingForegroundColor := Value;
         Invalidate;
      end;
end;

{ Read method for property RingWidth }
function TPSCircleGauge.GetRingWidth : Byte;
begin
     Result := FRingWidth;
end;

{ Write method for property RingWidth }
procedure TPSCircleGauge.SetRingWidth(Value : Byte);
begin
     {Minimum Bar Width is 5}
     If Value < 5 Then begin
        Value := 5;
        If GetErrorChecking then ShowMessage('BarWidth can not be less than 5');
     end;
     If FRingWidth<> Value then begin
        FRingWidth := Value;
        Invalidate;
     end;
end;

{ Read method for property SectorDegree }
function TPSCircleGauge.GetSectorDegree : Integer;
begin
     Result := FSectorDegree;
end;

{ Write method for property SectorDegree }
procedure TPSCircleGauge.SetSectorDegree(Value : Integer);
begin
     {don't allow any less than 10 degrees as below this the rings won't
     draw properly}
     If Value < 10 then begin
        if GetErrorChecking Then ShowMessage('The Sector Degree can''t be set to less than 10');
        Value := 10;
     end;

     {270 is maximum value}
     If Value > 270 then begin
     if GetErrorChecking Then ShowMessage('The Sector Degree can''t be set to more than 270');
        Value := 270;
     end;

     If FSectorDegree <> Value then begin
        FSectorDegree := Value;
        Invalidate;
     end;

     {Work Out the drawfactor}

     Case FSectorDegree of

          10..60    : DrawFactor := 1;
          61..120   : DrawFactor := 2;
          121..180  : DrawFactor := 3;
          181..270  : DrawFactor := 4;
     else
         DrawFactor := 5;

     end;

end;

{ Override OnClick handler from TGraphicControl }
procedure TPSCircleGauge.Click;
begin
     { Code to execute before activating click
       behavior of component's parent class }

     { Activate click behavior of parent }
     inherited Click;

     { Code to execute after click behavior
       of parent }

end;

{ Override OnDblClick handler from TGraphicControl }
procedure TPSCircleGauge.DblClick;
begin
     { Code to execute before activating double-click
       behavior of component's parent class }

     { Activate double-click behavior of parent }
     inherited DblClick;

     { Code to execute after double-click behavior
       of parent }

end;

{ Override OnDragDrop handler from TGraphicControl }
procedure TPSCircleGauge.DragDrop(DragObject: TObject; X, Y: Integer);
begin
     inherited DragDrop(DragObject, X, Y);
end;

{ Override OnMouseDown handler from TGraphicControl }
procedure TPSCircleGauge.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     inherited MouseDown(Button, Shift, X, Y);
end;

{ Override OnMouseMove handler from TGraphicControl }
procedure TPSCircleGauge.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
     inherited MouseMove(Shift, X, Y);
end;

{ Override OnMouseUp handler from TGraphicControl }
procedure TPSCircleGauge.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     inherited MouseUp(Button, Shift, X, Y);
end;

function TPSCircleGauge.AdjustProgressValue(ProgressValue : Integer) : Integer;
Var
   RoundedValue : Integer;
begin
     {***************** WARNING **********************************************}
     {Be careful playing with this routine as it will effect the floodfill    }
     {calls in the DrawGauge routine. It took a long time to get this right.  }
     {************************************************************************}
     { this routine returns either                                            }
     { 0 if passed 0                                                          }
     { if less than (MinValue + RoundValue) then it returns the               }
     { (ProgressValue + roundedValue)                                         }
     { or if ProgressValue is greater than MinValue + RoundValue  it returns  }
     { The ProgressValue.                                                     }
     {************************************************************************}

     { Find out which is greater min or max values                            }
     if GetMaxValue > GetMinValue Then
        RoundedValue := Round((GetMaxValue - GetMinValue) / 100) * DrawFactor
     else
        RoundedValue := Round((GetMinValue - GetMaxValue) / 100) * DrawFactor;
        {Return the appropriate value}
        If ProgressValue > GetMinValue then
           begin
           if ProgressValue < (RoundedValue + GetMinValue) then
              begin
                   Result := GetMinValue + RoundedValue
              end
           else
               begin
                    Result:= ProgressValue;
               end;
           end
           else
           {this has to go in  so as to be able to progress value will go down to MinValue}
           begin
                Result := GetMinValue;
           end;

end;

procedure TPSCircleGauge.CaptionTextChanged(var Message: TMessage);
Begin
     Invalidate
end;

constructor TPSCircleGauge.Create(AOwner: TComponent);
begin
     { Call the Create method of the parent class }
     inherited Create(AOwner);

     { AutoInitialize sets the initial values of variables and      }
     { properties; also, it creates objects for properties of       }
     { standard Delphi object types (e.g., TFont, TTimer,           }
     { TPicture) and for any variables marked as objects.           }
     { AutoInitialize method is generated by Component Create.      }
     AutoInitialize;
     { Code to perform other tasks when the component is created }
     ControlStyle := ControlStyle + [csOpaque];
     Caption := Name;
     Refresh;
end;

{ This converts a degrees amount to Rads }
function TPSCircleGauge.DegToRad(InputDegrees: Double) : Double;
begin
     {changes degrees to radius}
     Result := InputDegrees*pi/180;
end;

destructor TPSCircleGauge.Destroy;
begin
     { AutoDestroy, which is generated by Component Create, frees any   }
     { objects created by AutoInitialize.                               }
     AutoDestroy;

     { Here, free any other dynamic objects that the component methods  }
     { created but have not yet freed.  Also perform any other clean-up }
     { operations needed before the component is destroyed.             }

     { Last, free the component by calling the Destroy method of the    }
     { parent class.                                                    }
     inherited Destroy;
end;

procedure TPSCircleGauge.DrawArcs( GaugeLeft, GaugeTop, GaugeRight, GaugeBottom, OuterRadius, InnerRadius, HalfTheSectorDegree, D1, D2: Integer);
Var
   StartX1,StartY1,EndX1,EndY1 : Integer;
   StartX2,StartY2,EndX2,EndY2 : Integer;
   StartX3,StartY3,EndX3,EndY3 : Integer;
   StartX4,StartY4,EndX4,EndY4 : Integer;
   Pnx1,Pny1,Pnx2,Pny2,PnDeg:integer;
   Counter:integer;
begin
     {Draws the arcs, and adds the min and max values to the gauge}
     With BackBuffer.Canvas do begin
          {Draw the Outer Arc}
            StartX1 := GetArcPointX(-HalfTheSectorDegree, GaugeLeft, GaugeRight,   OuterRadius + 3);   {arc Shadow}
            StartY1 := GetArcPointY(-HalfTheSectorDegree, GaugeTop,  GaugeBottom,  OuterRadius + 3);   {arc Shadow}
            EndX1   := GetArcPointX( HalfTheSectorDegree, GaugeLeft, GaugeRight,   OuterRadius + 3);   {arc Shadow}
            EndY1   := GetArcPointY( HalfTheSectorDegree, GaugeTop,  GaugeBottom,  OuterRadius + 3);   {arc Shadow}
            StartX2 := GetArcPointX(-HalfTheSectorDegree, GaugeLeft, GaugeRight,   InnerRadius - 4);   {Idicator Arc}
            StartY2 := GetArcPointY(-HalfTheSectorDegree, GaugeTop,  GaugeBottom,  InnerRadius - 4);   {Idicator Arc}
            EndX2   := GetArcPointX(HalfTheSectorDegree,  GaugeLeft, GaugeRight,   InnerRadius - 4);   {Idicator Arc}
            EndY2   := GetArcPointY(HalfTheSectorDegree,  GaugeTop,  GaugeBottom,  InnerRadius - 4);   {Idicator Arc}
            StartX3 := GetArcPointX(-HalfTheSectorDegree+2,GaugeLeft, GaugeRight,   OuterRadius);      {outer arc}
            StartY3 := GetArcPointY(-HalfTheSectorDegree+2,GaugeTop,  GaugeBottom,  OuterRadius);      {outer arc}
            EndX3   := GetArcPointX(HalfTheSectorDegree-2, GaugeLeft, GaugeRight,   OuterRadius);      {outer arc}
            EndY3   := GetArcPointY(HalfTheSectorDegree-2, GaugeTop,  GaugeBottom,  OuterRadius);      {outer arc}
            StartX4 := GetArcPointX(-HalfTheSectorDegree+2,GaugeLeft, GaugeRight,   InnerRadius);      {Inner arc}
            StartY4 := GetArcPointY(-HalfTheSectorDegree+2,GaugeTop,  GaugeBottom,  InnerRadius);      {Inner arc}
            EndX4   := GetArcPointX(HalfTheSectorDegree-2, GaugeLeft, GaugeRight,   InnerRadius);      {Inner arc}
            EndY4   := GetArcPointY(HalfTheSectorDegree-2, GaugeTop,  GaugeBottom,  InnerRadius);      {Inner arc}
            {This the background arc and covers most of the display)
            {Draw the outer half of the first arc section at the bottom of the Panel}
            Arc(GaugeLeft + D1, GaugeTop + D1, GaugeRight - D1, GaugeBottom - D1, StartX3,StartY3,EndX3,EndY3); {Draw Outer Arc}
            {Draw the Inner half of the first arc section at the bottom of the Panel}
            Arc(GaugeLeft + D2, GaugeTop + D2, GaugeRight - D2, GaugeBottom - D2, StartX4,StartY4,EndX4,EndY4); {Draw Inner Arc}
            {Draw line at end of Arcs}
            MoveTo(StartX1,StartY1);
            LineTo(StartX2,StartY2);
            {Draw Lines at start of Arcs}
            MoveTo(EndX1,EndY1);
            LineTo(EndX2,EndY2);

            {Draw The Arc Shadow}
            Pen.Color := clWhite;
            Pen.Width := 1;
            Arc( GaugeLeft+D1-2, GaugeTop+D1-2, GaugeRight-D1+2, GaugeBottom-d1+2, Startx1, StartY1, EndX1, EndY1);

            {Draw then indicator around the inside of the Gauge}
            Pen.Color := GetIndicatorColor;
            Pen.Width := 1;
            Arc( GaugeLeft+D2+3 , GaugeTop+D2+3, GaugeRight-D2-3, GaugeBottom-D2-3, Startx2, StartY2, EndX2, EndY2);

            {Draw the ticks around the inside of the gauge}
            {Draw the all but the last one}
            for Counter := 0 to 19 do Begin
                PnDeg := HalfTheSectorDegree + Counter*5*(360-(HalfTheSectorDegree*2)) Div 100;
                Pnx1 := GetArcPointX(PnDeg, GaugeLeft, GaugeRight, InnerRadius - 3);
                Pny1 := GetArcPointY(PnDeg, GaugeTop, GaugeBottom, InnerRadius - 3);
                {Make each second one longer}
                If Counter Mod 2 = 0 then begin
                   Pnx2 := GetArcPointX(PnDeg, GaugeLeft, GaugeRight, InnerRadius - 12);
                   Pny2 := GetArcPointY(PnDeg, GaugeTop, GaugeBottom, InnerRadius - 12);
                 end
                 else begin
                      Pnx2 := GetArcPointX(PnDeg, GaugeLeft, GaugeRight, InnerRadius - 8);
                      Pny2 := GetArcPointY(PnDeg, GaugeTop, GaugeBottom, InnerRadius - 8);
                 end;

                 MoveTo(pnx1,Pny1);
                 LineTo(Pnx2,pny2);

                 {Set up a couple of bits of  font Info}
                 Font.Name := 'Arial';
                 Font.Style := [];
                 Font.Size :=GetIndicatorFontSize;

                 {Make sure the background of the text is clear}
                 Brush.Style := bsClear;

                 {Draw the starting value near the First mark}
                 if Counter = 0 then begin
                    TextOut( Pnx2+5, Pny2 - ((TextHeight(IntToStr(GetMinValue)) div 2)),IntToStr(GetMinValue));
                 end;
            end;
            {Draw the last Tick}
            PnDeg:=HalfTheSectorDegree+(360-(HalfTheSectorDegree*2));
            Pnx1:=GetArcPointX(PnDeg, GaugeLeft, GaugeRight,InnerRadius-3);
            Pny1:=GetArcPointY(PnDeg, GaugeTop,  GaugeBottom,InnerRadius-3);
            Pnx2:=GetArcPointX(PnDeg, GaugeLeft, GaugeRight,InnerRadius-12);
            Pny2:=GetArcPointY(PnDeg, GaugeTop,  GaugeBottom,InnerRadius-12);

            MoveTo(Pnx1,Pny1);
            LineTo(Pnx2,Pny2);

      {Draw the maximum value near the last marker}

       TextOut( Pnx2 - 5 - TextWidth(IntToStr(GetMaxValue)),
                Pny2 - ((TextHeight(IntToStr(GetMaxValue)) div 2)),
                     IntToStr(GetMaxValue));


       end;
end;

procedure TPSCircleGauge.DrawBackground;

begin
     With backBuffer.Canvas Do
         begin
              { This will change the color of the outline.                     }
              { If the "HasOutline" is set to true the pen will draw a black   }
              { line around the component. If it is set to false the line will }
              { be the same color as the component. This give the illusion of  }
              { no outline.                                                    }

              If Not GetHasOutline then
                 pen.color := GetBackgroundColor
                 else Pen.Color := clBlack;
                 Brush.Color := GetBackgroundColor;
                 Rectangle(0, 0, Width, Height);
         end;
end;

procedure TPSCircleGauge.DrawCaptionText;
 var
    TextX, TextY : Integer;
begin
     with BackBuffer.Canvas do begin
          {Use half ot the width less the width of the text
          this makes the text appear horizontally in the middle of the component.
          The same for the vertical location }

          TextX := (Width - TextWidth(Caption)) Div 2;
          TextY := ((Height - TextHeight(Caption)) Div 2) - 30;

          Brush.Style := bsClear;
          Font.Name := 'Arial';
          font.style := [fsBold];
          Font.Size := GetCaptionFontSize;
          pen.color := clblack;
          if Length(Caption) > 0 then
             Rectangle( TextX-12, TextY-2, TextX+TextWidth(Caption)+12,TextY+TextHeight(Caption)+2);
          TextOut(TextX,TextY,Caption);
     end;
end;

procedure TPSCircleGauge.DrawGauge( GaugeLeft, GaugeTop, GaugeRight, GaugeBottom, OuterRadius, InnerRadius, TheSectorDegree, TheProgressValue: Integer);
var

  P1x1,P1y1,P1x2,P1y2:integer;
  D1,D2,OverallWidth :integer;
  P1Deg, HalfTheSectorDegree : integer;

begin
     with BackBuffer.Canvas do begin
          pen.color := clBlack;
          pen.mode  := pmCopy;
          Pen.width := 1;

          {Work out some internal variables}
          HalfTheSectorDegree:=TheSectorDegree Div 2;
          OverallWidth:=GetR(GaugeLeft,GaugeRight);
          D1:=OverallWidth - OuterRadius;
          D2:=OverallWidth - InnerRadius;
          DrawArcs(GaugeLeft, GaugeTop,GaugeRight,GaugeBottom,OuterRadius, InnerRadius, HalfTheSectorDegree, D1, D2);

      {work out the degree for the line that splits the two sections of the ring}
      P1Deg:=HalfTheSectorDegree+(TheProgressValue-GetMinValue)*(360-TheSectorDegree) Div (GetMaxValue-GetMinValue);
      P1x1:=GetArcPointX(P1Deg,GaugeLeft, GaugeRight, OuterRadius);
      P1y1:=GetArcPointY(P1Deg,GaugeTop,  GaugeBottom,OuterRadius);
      P1x2:=GetArcPointX(P1Deg,GaugeLeft, GaugeRight,InnerRadius-4);
      P1y2:=GetArcPointY(P1Deg,GaugeTop,  GaugeBottom,InnerRadius-4);

      if TheProgressValue = GetMinValue then begin
         P1Deg:=HalfTheSectorDegree+(50)*(360-TheSectorDegree) Div (GetMaxValue-GetMinValue);
         Brush.Color:=GetRingBackgroundColor;
         FloodFill( GetArcPointX(P1Deg,GaugeLeft,GaugeRight, OuterRadius-3),
                    GetArcPointY(P1Deg,GaugeTop, GaugeBottom,OuterRadius-3),
                    clBlack, fsBorder);
      end
      else if ((TheProgressValue > GetMinValue) and (TheProgressValue < GetMaxValue)) then begin

           { fill the whole thing with the back color}
           P1Deg:=HalfTheSectorDegree+(GetMaxValue-1)*(360-TheSectorDegree) Div (GetMaxValue-GetMinValue);
           Brush.Color:=GetRingBackgroundColor;
           FloodFill( GetArcPointX(P1Deg,GaugeLeft,GaugeRight, OuterRadius-3),
                      GetArcPointY(P1Deg,GaugeTop, GaugeBottom,OuterRadius-3),
                      clBlack, fsBorder);

           {Draw the spilt line between the first and second sections}
           Pen.Color := clBlack;
           Pen.Width := 1;
           MoveTo(P1x1,P1y1);
           LineTo(P1x2,P1y2);

           {Now fill the first section with the foreground color}
           P1Deg:=HalfTheSectorDegree+(TheProgressValue - GetMinValue)*(360-TheSectorDegree) Div (GetMaxValue-GetMinValue);
           Brush.Color:=GetRingForegroundColor;
           FloodFill( GetArcPointX(P1Deg-2,GaugeLeft,GaugeRight, OuterRadius-3),
                      GetArcPointY(P1Deg-2,GaugeTop, GaugeBottom,OuterRadius-3),
                      clBlack, fsBorder);
      end
      else if TheProgressValue = GetMaxValue Then begin

           P1Deg:=HalfTheSectorDegree+(50)*(360-TheSectorDegree) Div (GetMaxValue-GetMinValue);
         Brush.Color:=GetRingForegroundColor;
         FloodFill( GetArcPointX(P1Deg,GaugeLeft,GaugeRight, OuterRadius-3),
                    GetArcPointY(P1Deg,GaugeTop, GaugeBottom,OuterRadius-3),
                    clBlack, fsBorder);
      end;




     end;
end;

{ Draws the current Progress value as text in the middle of gauge }
procedure TPSCircleGauge.DrawValueText;
     { Internal declarations for method }
     { type }
     { . . . }
var
    TheValueText : String;
    TextX, TextY : Integer;
begin
     with BackBuffer.Canvas do begin
          { ********** Draw the ProgressValue *************** }
          {Convert the progrees value to a string}
          TheValueText := IntToStr(GetProgressValue);
          {Use half of the width less the width of the text
          this makes the text appear horizontally in the middle of the component.
          The same for the vertical location }

          TextX := (Width - TextWidth(TheValueText)) Div 2;
          TextY := (Height - TextHeight(TheValueText)) Div 2;

          Brush.Style := bsClear;
          Font.Name := 'Arial';
          font.style := [fsBold];
          Font.Size := GetCaptionFontSize;
          pen.color := clblack;
          Rectangle( TextX-12, TextY-2,
                     TextX+TextWidth(TheValueText)+12,
                     TextY+TextHeight(TheValueText)+2);
          TextOut(TextX,TextY,TheValueText);
     end;
end;

{ This procedure flips the contents of the backbuffer to the screen }
procedure TPSCircleGauge.FlipBuffers;
     { Internal declarations for method }
     { type }
     { . . . }
var
     ARect : TRect;
begin
     ARect := Rect(0,0,Width,Height);
     Canvas.CopyRect(ARect,BackBuffer.Canvas,ARect);
end;

{ Returns an X point on an arc by using the degrees }
function TPSCircleGauge.GetArcPointX(Degrees : Double; GaugeLeft, GaugeRight, OuterOrInnerRadius: Integer) : Integer;
var
  TempInteger : Integer;
begin
     TempInteger := Round(OuterOrInnerRadius*Sin(DegToRad(Degrees)));
     Result := GetRx(GaugeLeft, GaugeRight) - TempInteger;
end;

{ Returns an Y point on an arc by using the degrees }
function TPSCircleGauge.GetArcPointY(Degrees : Double; GaugeTop, GaugeBottom, OuterOrInnerRadius : Integer) : Integer;
var
   TempInteger : Integer;
begin
     TempInteger := Round(OuterOrInnerRadius*cos(DegToRad(Degrees)));
     Result:=GetRy(GaugeTop,GaugeBottom)+Tempinteger;
end;

function TPSCircleGauge.GetR(x1, x2 : Integer) : integer;
begin
     result := abs(x2-x1) div 2;
end;

function TPSCircleGauge.GetRx(x1,x2 : Integer) : Integer;
begin
     result := x1+(x2-x1) div 2;
end;

function TPSCircleGauge.GetRy(y1, y2 : Integer) : integer;
begin
     result := y1+(y2-y1) div 2;
end;

procedure TPSCircleGauge.Loaded;
begin
     inherited Loaded;

     { Perform any component setup that depends on the property
       values having been set }

end;

procedure TPSCircleGauge.Paint;
begin
     { Draw the component using the methods supplied by its Canvas
       property (of type TCanvas).  }

       {Set up some variable values}
       if Width<130 Then Width:=130;
        if Height<130 Then Height:=130;
        if Width<Height Then begin
           GaugeTop:=10;
           GaugeLeft:=5;
           GaugeWidth:=Width-10;
           GaugeHeight:=Width-10;
           OuterRadius := (GaugeWidth Div 2)-15;
           InnerRadius:= OuterRadius - GetRingWidth;
           {NeedleRadius:=(FGaugeWidth Div 2)-25;}
        end
        else begin
           GaugeTop:=10;
           GaugeLeft:=5;
           GaugeWidth:=Height-10;
           GaugeHeight:=Height-10;
           OuterRadius := (GaugeWidth Div 2)-15;
           InnerRadius:= OuterRadius - GetRingWidth;
           {NeedleRadius:=(FGaugeWidth Div 2)-25;}
        end;
        BackBuffer.Height := Height;
        BackBuffer.Width := Width;

        DrawBackground;
        {Set some variables}
        GaugeRight := GaugeLeft + GaugeWidth;
        GaugeBottom := GaugeTop + GaugeHeight;
        DrawGauge( GaugeLeft, GaugeTop, GaugeRight, GaugeBottom, OuterRadius,
                   InnerRadius, GetSectorDegree, AdjustProgressValue(GetProgressValue));
        DrawValueText;
        DrawCaptionText;
        FlipBuffers;
end;

procedure TPSCircleGauge.WMSize(var Message: TWMSize);
var
     W, H: Integer;
begin
     inherited;

        Refresh;
     { Copy the new width and height of the component
       so we can use SetBounds to change both at once }
     W := Width;
     H := Height;

     { Code to check and adjust W and H }

     { Update the component size if we adjusted W or H }
     if (W <> Width) or (H <> Height) then
        inherited SetBounds(Left, Top, W, H);

     { Code to update dimensions of any owned sub-components
       by reading their Height and Width properties and updating
       via their SetBounds methods }

     Message.Result := 0;
end;


end.
